searchNodes=[{"doc":"MidiProto See MidiProto.Parser for information about parsing incoming MIDI messages into data structures. See MidiProto.Message for information about messages and encoding them into the wire. Examples Generating a note-on message for middle C and encoding it for transmission: iex&gt; MidiProto.Message.NoteOn.init(0, 60, 127) ...&gt; |&gt; MidiProto.Message.encode() &lt;&lt;0x90, 0x3c, 0x7f&gt;&gt; Parsing an incoming packets: iex&gt; MidiProto.Parser.init() ...&gt; |&gt; MidiProto.Parser.append(&lt;&lt;0x90, 0x3c, 0x7f&gt;&gt;) ...&gt; |&gt; MidiProto.Parser.parse() {:ok, [%MidiProto.Message.NoteOn{channel: 0, note_number: 60, velocity: 127}], %MidiProto.Parser{}} Generating a Firmata message: iex&gt; MidiProto.Firmata.FirmwareQuery.init() ...&gt; |&gt; MidiProto.Message.encode() &lt;&lt;0xf0, 0x79, 0xf7&gt;&gt; Converting a MIDI message into a Firmata message: iex&gt; MidiProto.Message.SystemExclusive.init(0x79, &quot;&quot;) ...&gt; |&gt; MidiProto.Firmata.convert() {:ok, %MidiProto.Firmata.FirmwareQuery{}}","ref":"MidiProto.html","title":"MidiProto","type":"module"},{"doc":"","ref":"MidiProto.html#t:nybble/0","title":"MidiProto.nybble/0","type":"type"},{"doc":"","ref":"MidiProto.html#t:seven_bit_int/0","title":"MidiProto.seven_bit_int/0","type":"type"},{"doc":"This module converts incoming MIDI messages into Firmata messages if possible.","ref":"MidiProto.Firmata.html","title":"MidiProto.Firmata","type":"module"},{"doc":"Given a MIDI message struct, convert it to it&#39;s equivalent Firmata message.","ref":"MidiProto.Firmata.html#convert/1","title":"MidiProto.Firmata.convert/1","type":"function"},{"doc":"","ref":"MidiProto.Firmata.html#t:t/0","title":"MidiProto.Firmata.t/0","type":"type"},{"doc":"Represents a Firmata analog mapping query implemented using a MIDI SysEx message.","ref":"MidiProto.Firmata.AnalogMappingQuery.html","title":"MidiProto.Firmata.AnalogMappingQuery","type":"module"},{"doc":"Initialise a new AnalogMappingQuery struct.","ref":"MidiProto.Firmata.AnalogMappingQuery.html#init/0","title":"MidiProto.Firmata.AnalogMappingQuery.init/0","type":"function"},{"doc":"","ref":"MidiProto.Firmata.AnalogMappingQuery.html#t:t/0","title":"MidiProto.Firmata.AnalogMappingQuery.t/0","type":"type"},{"doc":"Represents a Firmata analog mapping response using a MIDI SysEx message.","ref":"MidiProto.Firmata.AnalogMappingResponse.html","title":"MidiProto.Firmata.AnalogMappingResponse","type":"module"},{"doc":"Initialise a AnalogMappingResponse struct.","ref":"MidiProto.Firmata.AnalogMappingResponse.html#init/1","title":"MidiProto.Firmata.AnalogMappingResponse.init/1","type":"function"},{"doc":"","ref":"MidiProto.Firmata.AnalogMappingResponse.html#t:pin_mapping/0","title":"MidiProto.Firmata.AnalogMappingResponse.pin_mapping/0","type":"type"},{"doc":"","ref":"MidiProto.Firmata.AnalogMappingResponse.html#t:t/0","title":"MidiProto.Firmata.AnalogMappingResponse.t/0","type":"type"},{"doc":"Represents a Firmata capability query implemented using a MIDI SysEx message.","ref":"MidiProto.Firmata.CapabilityQuery.html","title":"MidiProto.Firmata.CapabilityQuery","type":"module"},{"doc":"Initialise a new CapabilityQuery struct.","ref":"MidiProto.Firmata.CapabilityQuery.html#init/0","title":"MidiProto.Firmata.CapabilityQuery.init/0","type":"function"},{"doc":"","ref":"MidiProto.Firmata.CapabilityQuery.html#t:t/0","title":"MidiProto.Firmata.CapabilityQuery.t/0","type":"type"},{"doc":"Represents a Firmata capability response implemented using a MIDI SysEx message.","ref":"MidiProto.Firmata.CapabilityResponse.html","title":"MidiProto.Firmata.CapabilityResponse","type":"module"},{"doc":"Initialise a new CapabilityResponse struct.","ref":"MidiProto.Firmata.CapabilityResponse.html#init/1","title":"MidiProto.Firmata.CapabilityResponse.init/1","type":"function"},{"doc":"","ref":"MidiProto.Firmata.CapabilityResponse.html#t:pin_mode/0","title":"MidiProto.Firmata.CapabilityResponse.pin_mode/0","type":"type"},{"doc":"","ref":"MidiProto.Firmata.CapabilityResponse.html#t:pin_resolution/0","title":"MidiProto.Firmata.CapabilityResponse.pin_resolution/0","type":"type"},{"doc":"","ref":"MidiProto.Firmata.CapabilityResponse.html#t:t/0","title":"MidiProto.Firmata.CapabilityResponse.t/0","type":"type"},{"doc":"Represents a Firmata extended analog message using a MIDI SysEx message.","ref":"MidiProto.Firmata.ExtendedAnalog.html","title":"MidiProto.Firmata.ExtendedAnalog","type":"module"},{"doc":"Initialise an ExtendedAnalog struct.","ref":"MidiProto.Firmata.ExtendedAnalog.html#init/2","title":"MidiProto.Firmata.ExtendedAnalog.init/2","type":"function"},{"doc":"","ref":"MidiProto.Firmata.ExtendedAnalog.html#t:t/0","title":"MidiProto.Firmata.ExtendedAnalog.t/0","type":"type"},{"doc":"Represents a Firmata firmware query implemented using a MIDI SysEx message.","ref":"MidiProto.Firmata.FirmwareQuery.html","title":"MidiProto.Firmata.FirmwareQuery","type":"module"},{"doc":"Initialise a FirmwareQuery struct.","ref":"MidiProto.Firmata.FirmwareQuery.html#init/0","title":"MidiProto.Firmata.FirmwareQuery.init/0","type":"function"},{"doc":"","ref":"MidiProto.Firmata.FirmwareQuery.html#t:t/0","title":"MidiProto.Firmata.FirmwareQuery.t/0","type":"type"},{"doc":"Represents a Firmata firmware response using a MIDI SysEx message.","ref":"MidiProto.Firmata.FirmwareResponse.html","title":"MidiProto.Firmata.FirmwareResponse","type":"module"},{"doc":"Initialise a FirmwareResponse struct.","ref":"MidiProto.Firmata.FirmwareResponse.html#init/3","title":"MidiProto.Firmata.FirmwareResponse.init/3","type":"function"},{"doc":"","ref":"MidiProto.Firmata.FirmwareResponse.html#t:t/0","title":"MidiProto.Firmata.FirmwareResponse.t/0","type":"type"},{"doc":"Represents a Firmata pin state query implemented using a MIDI SysEx message.","ref":"MidiProto.Firmata.PinStateQuery.html","title":"MidiProto.Firmata.PinStateQuery","type":"module"},{"doc":"Initialise a new PinStateQuery struct.","ref":"MidiProto.Firmata.PinStateQuery.html#init/1","title":"MidiProto.Firmata.PinStateQuery.init/1","type":"function"},{"doc":"","ref":"MidiProto.Firmata.PinStateQuery.html#t:t/0","title":"MidiProto.Firmata.PinStateQuery.t/0","type":"type"},{"doc":"Represents a Firmata pin state response implemented using a MIDI SysEx message.","ref":"MidiProto.Firmata.PinStateResponse.html","title":"MidiProto.Firmata.PinStateResponse","type":"module"},{"doc":"Initialise a new PinStateResponse struct.","ref":"MidiProto.Firmata.PinStateResponse.html#init/3","title":"MidiProto.Firmata.PinStateResponse.init/3","type":"function"},{"doc":"","ref":"MidiProto.Firmata.PinStateResponse.html#t:pin_mode/0","title":"MidiProto.Firmata.PinStateResponse.pin_mode/0","type":"type"},{"doc":"","ref":"MidiProto.Firmata.PinStateResponse.html#t:t/0","title":"MidiProto.Firmata.PinStateResponse.t/0","type":"type"},{"doc":"Represents the Firmata sampling interval message.","ref":"MidiProto.Firmata.SamplingInterval.html","title":"MidiProto.Firmata.SamplingInterval","type":"module"},{"doc":"Initialise a new SamplingInterval struct.","ref":"MidiProto.Firmata.SamplingInterval.html#init/1","title":"MidiProto.Firmata.SamplingInterval.init/1","type":"function"},{"doc":"","ref":"MidiProto.Firmata.SamplingInterval.html#t:t/0","title":"MidiProto.Firmata.SamplingInterval.t/0","type":"type"},{"doc":"Handles encoding and decoding strings (and binaries) using Firmata&#39;s two-byte encoding method.","ref":"MidiProto.Firmata.String.html","title":"MidiProto.Firmata.String","type":"module"},{"doc":"Decode two-byte sequences back into a binary: Example iex&gt; &lt;&lt;0x4d, 0x00, 0x61, 0x00, 0x72, 0x00, 0x74, 0x00, 0x79, 0x00, 0x20, 0x00, 0x4d, 0x00, 0x63, 0x00, 0x46, 0x00, 0x6c, 0x00, 0x79, 0x00&gt;&gt; ...&gt; |&gt; decode() {:ok, &quot;Marty McFly&quot;}","ref":"MidiProto.Firmata.String.html#decode/1","title":"MidiProto.Firmata.String.decode/1","type":"function"},{"doc":"Encode binary values into two-byte sequences: Example iex&gt; &quot;Marty McFly&quot; ...&gt; |&gt; encode() {:ok, &lt;&lt;0x4d, 0x00, 0x61, 0x00, 0x72, 0x00, 0x74, 0x00, 0x79, 0x00, 0x20, 0x00, 0x4d, 0x00, 0x63, 0x00, 0x46, 0x00, 0x6c, 0x00, 0x79, 0x00&gt;&gt;}","ref":"MidiProto.Firmata.String.html#encode/1","title":"MidiProto.Firmata.String.encode/1","type":"function"},{"doc":"Represents a Firmata string data message.","ref":"MidiProto.Firmata.StringData.html","title":"MidiProto.Firmata.StringData","type":"module"},{"doc":"Initialise a new StringData struct.","ref":"MidiProto.Firmata.StringData.html#init/1","title":"MidiProto.Firmata.StringData.init/1","type":"function"},{"doc":"","ref":"MidiProto.Firmata.StringData.html#t:t/0","title":"MidiProto.Firmata.StringData.t/0","type":"type"},{"doc":"Represents a Firmata user-defined command implemented using a MIDI SysEx message.","ref":"MidiProto.Firmata.UserDefined.html","title":"MidiProto.Firmata.UserDefined","type":"module"},{"doc":"Initialise a new UserDefined struct.","ref":"MidiProto.Firmata.UserDefined.html#init/2","title":"MidiProto.Firmata.UserDefined.init/2","type":"function"},{"doc":"","ref":"MidiProto.Firmata.UserDefined.html#t:command_id/0","title":"MidiProto.Firmata.UserDefined.command_id/0","type":"type"},{"doc":"","ref":"MidiProto.Firmata.UserDefined.html#t:t/0","title":"MidiProto.Firmata.UserDefined.t/0","type":"type"},{"doc":"Common behaviour for all MIDI message types. Allows you to check the capabilities of a MIDI message or encode it into a message for transmission.","ref":"MidiProto.Message.html","title":"MidiProto.Message","type":"protocol"},{"doc":"Is the message a active sense message?","ref":"MidiProto.Message.html#active_sense?/1","title":"MidiProto.Message.active_sense?/1","type":"function"},{"doc":"Is the message a channel pressure message?","ref":"MidiProto.Message.html#channel_pressure?/1","title":"MidiProto.Message.channel_pressure?/1","type":"function"},{"doc":"Is the message a continue message?","ref":"MidiProto.Message.html#continue?/1","title":"MidiProto.Message.continue?/1","type":"function"},{"doc":"Is the message a control change message?","ref":"MidiProto.Message.html#control_change?/1","title":"MidiProto.Message.control_change?/1","type":"function"},{"doc":"Encode the message into a binary for sending.","ref":"MidiProto.Message.html#encode/1","title":"MidiProto.Message.encode/1","type":"function"},{"doc":"Is the message a note-off message?","ref":"MidiProto.Message.html#note_off?/1","title":"MidiProto.Message.note_off?/1","type":"function"},{"doc":"Is the message a note-on message?","ref":"MidiProto.Message.html#note_on?/1","title":"MidiProto.Message.note_on?/1","type":"function"},{"doc":"Is the message a pitch bend message?","ref":"MidiProto.Message.html#pitch_bend?/1","title":"MidiProto.Message.pitch_bend?/1","type":"function"},{"doc":"Is the message a polyphonic pressure message?","ref":"MidiProto.Message.html#polyphonic_pressure?/1","title":"MidiProto.Message.polyphonic_pressure?/1","type":"function"},{"doc":"Is the message a program change message?","ref":"MidiProto.Message.html#program_change?/1","title":"MidiProto.Message.program_change?/1","type":"function"},{"doc":"Is the message a realtime message?","ref":"MidiProto.Message.html#realtime?/1","title":"MidiProto.Message.realtime?/1","type":"function"},{"doc":"Is the message a song position message?","ref":"MidiProto.Message.html#song_position?/1","title":"MidiProto.Message.song_position?/1","type":"function"},{"doc":"Is the message a song select message?","ref":"MidiProto.Message.html#song_select?/1","title":"MidiProto.Message.song_select?/1","type":"function"},{"doc":"Is the message a start message?","ref":"MidiProto.Message.html#start?/1","title":"MidiProto.Message.start?/1","type":"function"},{"doc":"Is the message a stop message?","ref":"MidiProto.Message.html#stop?/1","title":"MidiProto.Message.stop?/1","type":"function"},{"doc":"Is the message a system message?","ref":"MidiProto.Message.html#system?/1","title":"MidiProto.Message.system?/1","type":"function"},{"doc":"Is the message a system reset message?","ref":"MidiProto.Message.html#system_reset?/1","title":"MidiProto.Message.system_reset?/1","type":"function"},{"doc":"Is the message a time code quarter frame message?","ref":"MidiProto.Message.html#time_code_quarter_frame?/1","title":"MidiProto.Message.time_code_quarter_frame?/1","type":"function"},{"doc":"Is the message a timing clock message?","ref":"MidiProto.Message.html#timing_clock?/1","title":"MidiProto.Message.timing_clock?/1","type":"function"},{"doc":"Is the message a tune request message?","ref":"MidiProto.Message.html#tune_request?/1","title":"MidiProto.Message.tune_request?/1","type":"function"},{"doc":"","ref":"MidiProto.Message.html#t:t/0","title":"MidiProto.Message.t/0","type":"type"},{"doc":"A MIDI active sense system realtime message.","ref":"MidiProto.Message.ActiveSense.html","title":"MidiProto.Message.ActiveSense","type":"module"},{"doc":"Create a new MIDI active sense system realtime message.","ref":"MidiProto.Message.ActiveSense.html#init/0","title":"MidiProto.Message.ActiveSense.init/0","type":"function"},{"doc":"","ref":"MidiProto.Message.ActiveSense.html#t:t/0","title":"MidiProto.Message.ActiveSense.t/0","type":"type"},{"doc":"A MIDI channel pressure message.","ref":"MidiProto.Message.ChannelPressure.html","title":"MidiProto.Message.ChannelPressure","type":"module"},{"doc":"Create a new MIDI channel pressure message with the provided parameters.","ref":"MidiProto.Message.ChannelPressure.html#init/2","title":"MidiProto.Message.ChannelPressure.init/2","type":"function"},{"doc":"","ref":"MidiProto.Message.ChannelPressure.html#t:t/0","title":"MidiProto.Message.ChannelPressure.t/0","type":"type"},{"doc":"A MIDI continue system realtime message.","ref":"MidiProto.Message.Continue.html","title":"MidiProto.Message.Continue","type":"module"},{"doc":"Create a new MIDI continue system realtime message.","ref":"MidiProto.Message.Continue.html#init/0","title":"MidiProto.Message.Continue.init/0","type":"function"},{"doc":"","ref":"MidiProto.Message.Continue.html#t:t/0","title":"MidiProto.Message.Continue.t/0","type":"type"},{"doc":"A MIDI control change message.","ref":"MidiProto.Message.ControlChange.html","title":"MidiProto.Message.ControlChange","type":"module"},{"doc":"Create a new MIDI control change message with the provided parameters.","ref":"MidiProto.Message.ControlChange.html#init/3","title":"MidiProto.Message.ControlChange.init/3","type":"function"},{"doc":"","ref":"MidiProto.Message.ControlChange.html#t:t/0","title":"MidiProto.Message.ControlChange.t/0","type":"type"},{"doc":"A MIDI note-off message.","ref":"MidiProto.Message.NoteOff.html","title":"MidiProto.Message.NoteOff","type":"module"},{"doc":"Create a new MIDI note-off message with the provided parameters.","ref":"MidiProto.Message.NoteOff.html#init/3","title":"MidiProto.Message.NoteOff.init/3","type":"function"},{"doc":"","ref":"MidiProto.Message.NoteOff.html#t:t/0","title":"MidiProto.Message.NoteOff.t/0","type":"type"},{"doc":"A MIDI note-on message.","ref":"MidiProto.Message.NoteOn.html","title":"MidiProto.Message.NoteOn","type":"module"},{"doc":"Create a new MIDI note-on message with the provided parameters.","ref":"MidiProto.Message.NoteOn.html#init/3","title":"MidiProto.Message.NoteOn.init/3","type":"function"},{"doc":"","ref":"MidiProto.Message.NoteOn.html#t:t/0","title":"MidiProto.Message.NoteOn.t/0","type":"type"},{"doc":"A MIDI pitch bend message.","ref":"MidiProto.Message.PitchBend.html","title":"MidiProto.Message.PitchBend","type":"module"},{"doc":"Create a new MIDI pitch bend message with the provided parameters.","ref":"MidiProto.Message.PitchBend.html#init/2","title":"MidiProto.Message.PitchBend.init/2","type":"function"},{"doc":"","ref":"MidiProto.Message.PitchBend.html#t:t/0","title":"MidiProto.Message.PitchBend.t/0","type":"type"},{"doc":"A MIDI polyphonic pressure message.","ref":"MidiProto.Message.PolyphonicPressure.html","title":"MidiProto.Message.PolyphonicPressure","type":"module"},{"doc":"Create a new MIDI polyphonic pressure message with the provided parameters.","ref":"MidiProto.Message.PolyphonicPressure.html#init/3","title":"MidiProto.Message.PolyphonicPressure.init/3","type":"function"},{"doc":"","ref":"MidiProto.Message.PolyphonicPressure.html#t:t/0","title":"MidiProto.Message.PolyphonicPressure.t/0","type":"type"},{"doc":"A MIDI program change message.","ref":"MidiProto.Message.ProgramChange.html","title":"MidiProto.Message.ProgramChange","type":"module"},{"doc":"Create a new MIDI program change message with the provided parameters.","ref":"MidiProto.Message.ProgramChange.html#init/2","title":"MidiProto.Message.ProgramChange.init/2","type":"function"},{"doc":"","ref":"MidiProto.Message.ProgramChange.html#t:t/0","title":"MidiProto.Message.ProgramChange.t/0","type":"type"},{"doc":"A MIDI song position message.","ref":"MidiProto.Message.SongPosition.html","title":"MidiProto.Message.SongPosition","type":"module"},{"doc":"Create a new MIDI song position message with the provided parameters.","ref":"MidiProto.Message.SongPosition.html#init/1","title":"MidiProto.Message.SongPosition.init/1","type":"function"},{"doc":"","ref":"MidiProto.Message.SongPosition.html#t:t/0","title":"MidiProto.Message.SongPosition.t/0","type":"type"},{"doc":"A MIDI song select message.","ref":"MidiProto.Message.SongSelect.html","title":"MidiProto.Message.SongSelect","type":"module"},{"doc":"Create a new MIDI song select message with the provided parameters.","ref":"MidiProto.Message.SongSelect.html#init/1","title":"MidiProto.Message.SongSelect.init/1","type":"function"},{"doc":"","ref":"MidiProto.Message.SongSelect.html#t:t/0","title":"MidiProto.Message.SongSelect.t/0","type":"type"},{"doc":"A MIDI start system realtime message.","ref":"MidiProto.Message.Start.html","title":"MidiProto.Message.Start","type":"module"},{"doc":"Create a new MIDI start system realtime message.","ref":"MidiProto.Message.Start.html#init/0","title":"MidiProto.Message.Start.init/0","type":"function"},{"doc":"","ref":"MidiProto.Message.Start.html#t:t/0","title":"MidiProto.Message.Start.t/0","type":"type"},{"doc":"A MIDI stop system realtime message.","ref":"MidiProto.Message.Stop.html","title":"MidiProto.Message.Stop","type":"module"},{"doc":"Create a new MIDI stop system realtime message.","ref":"MidiProto.Message.Stop.html#init/0","title":"MidiProto.Message.Stop.init/0","type":"function"},{"doc":"","ref":"MidiProto.Message.Stop.html#t:t/0","title":"MidiProto.Message.Stop.t/0","type":"type"},{"doc":"A MIDI System Exclusive (SysEx) message.","ref":"MidiProto.Message.SystemExclusive.html","title":"MidiProto.Message.SystemExclusive","type":"module"},{"doc":"Initialise a new System Exclusive message. The payload parameter is a binary containing the payload to send. Be aware that the payload must be encoded such that the MSB of each byte is always zero (as per the MIDI spec). The easiest way to do this is to just base64 encode your data.","ref":"MidiProto.Message.SystemExclusive.html#init/2","title":"MidiProto.Message.SystemExclusive.init/2","type":"function"},{"doc":"","ref":"MidiProto.Message.SystemExclusive.html#t:t/0","title":"MidiProto.Message.SystemExclusive.t/0","type":"type"},{"doc":"","ref":"MidiProto.Message.SystemExclusive.html#t:vendor_id/0","title":"MidiProto.Message.SystemExclusive.vendor_id/0","type":"type"},{"doc":"A MIDI system reset system realtime message.","ref":"MidiProto.Message.SystemReset.html","title":"MidiProto.Message.SystemReset","type":"module"},{"doc":"Create a new MIDI system reset system realtime message.","ref":"MidiProto.Message.SystemReset.html#init/0","title":"MidiProto.Message.SystemReset.init/0","type":"function"},{"doc":"","ref":"MidiProto.Message.SystemReset.html#t:t/0","title":"MidiProto.Message.SystemReset.t/0","type":"type"},{"doc":"A MIDI time code quarter frame system realtime message.","ref":"MidiProto.Message.TimeCodeQuarterFrame.html","title":"MidiProto.Message.TimeCodeQuarterFrame","type":"module"},{"doc":"Create a new MIDI time code quarter frame system realtime message.","ref":"MidiProto.Message.TimeCodeQuarterFrame.html#init/1","title":"MidiProto.Message.TimeCodeQuarterFrame.init/1","type":"function"},{"doc":"","ref":"MidiProto.Message.TimeCodeQuarterFrame.html#t:t/0","title":"MidiProto.Message.TimeCodeQuarterFrame.t/0","type":"type"},{"doc":"A MIDI timing clock system realtime message.","ref":"MidiProto.Message.TimingClock.html","title":"MidiProto.Message.TimingClock","type":"module"},{"doc":"Create a new MIDI timing clock system realtime message.","ref":"MidiProto.Message.TimingClock.html#init/0","title":"MidiProto.Message.TimingClock.init/0","type":"function"},{"doc":"","ref":"MidiProto.Message.TimingClock.html#t:t/0","title":"MidiProto.Message.TimingClock.t/0","type":"type"},{"doc":"A MIDI tune request system message.","ref":"MidiProto.Message.TuneRequest.html","title":"MidiProto.Message.TuneRequest","type":"module"},{"doc":"Create a new MIDI tune request system message.","ref":"MidiProto.Message.TuneRequest.html#init/0","title":"MidiProto.Message.TuneRequest.init/0","type":"function"},{"doc":"","ref":"MidiProto.Message.TuneRequest.html#t:t/0","title":"MidiProto.Message.TuneRequest.t/0","type":"type"},{"doc":"Parses incoming MIDI data. Use this module to parse incoming MIDI data from your device and it&#39;ll convert it to a stream of message structs for you. Handy, eh? Usage We split the receiving data and the parsing functions into separate functions so that you have the flexibility to handle incoming data without having pay the cost of parsing until you&#39;re ready. Here&#39;s an example of parsing a single MIDI note on message: iex&gt; Parser.init() ...&gt; |&gt; Parser.append(&lt;&lt;145, 2, 3&gt;&gt;) ...&gt; |&gt; Parser.parse() {:ok, [%MidiProto.Message.NoteOn{channel: 1, note_number: 2, velocity: 3}], %Parser{}} You can call append/2 and parse/1 and number of times fill and empty the buffer as required.","ref":"MidiProto.Parser.html","title":"MidiProto.Parser","type":"module"},{"doc":"Append some new incoming data to the end of the parser buffer. Usually you append a packet at a time, but partial packets are fine, as long as they are completed before the call to parse/1 is made. Example iex&gt; Parser.init() ...&gt; |&gt; Parser.append(&lt;&lt;0xff&gt;&gt;) %Parser{buffer: &lt;&lt;0xff&gt;&gt;}","ref":"MidiProto.Parser.html#append/2","title":"MidiProto.Parser.append/2","type":"function"},{"doc":"Check if the parse buffer is empty.","ref":"MidiProto.Parser.html#empty?/1","title":"MidiProto.Parser.empty?/1","type":"function"},{"doc":"Initialize an empty parser struct ready to receive data. iex&gt; Parser.init() %Parser{}","ref":"MidiProto.Parser.html#init/0","title":"MidiProto.Parser.init/0","type":"function"},{"doc":"Parse the contents of the buffer, returning zero or more messages. Example iex&gt; Parser.init() ...&gt; |&gt; Parser.append(&lt;&lt;0xff&gt;&gt;) ...&gt; |&gt; Parser.parse() {:ok, [%SystemReset{}], %Parser{}}","ref":"MidiProto.Parser.html#parse/1","title":"MidiProto.Parser.parse/1","type":"function"},{"doc":"","ref":"MidiProto.Parser.html#t:t/0","title":"MidiProto.Parser.t/0","type":"type"}]